<?php

/**
 * ca_desc_producto actions.
 *
 * @package    cartera
 * @subpackage ca_desc_producto
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class ca_desc_productoActions extends sfQuery
{
  /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CA_DESCUENTO_PROD',
     ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(

    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CA_DESCUENTO_PROD' =>
        array(
            'id_descuento_prod' => 'id_descuento_prod',
            'descripcion' => 'descripcion',
            'fecha_ini' => 'fecha_ini',
            'fecha_fin' => 'fecha_fin',
            'porcentaje_general' => 'porcentaje_general',
            'fecha_log' => 'fecha_log',
            'activo' => 'activo',
            'observacion' => 'observacion',
            'fecha_cierre' => 'fecha_cierre',
            'motivo_cierre' => 'motivo_cierre',
            'usuario_log' => 'usuario_log'
        ),
    ); //por cada tabla especificar los campos del select
    protected $table_field_conditions = array(
        'CA_DESCUENTO_PROD' => array(
            'id_descuento_prod,a' => array('!=' => array(-1)),
            'id_descuento_prod,b' => array('=' => array('id_descuento_prod')),
            'descripcion' => array('LIKEALLPLUS' => array('descripcion', '%')),
            'fecha_log' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'activo' => array('=' => array('estado')),
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $fields_orderBy = array(
        'id_descuento_prod'
    ); //campos para el ordenamiento de la consulta

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = false;
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;


    /*
     * ------------VARIABLES PARA SERVICIO DE SUMATORIA - SUM
     *
     */
    protected $summatory_data = array(

    ); //se especifica por tabla los campos de suma y condiciones de filtro


    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_descuento_prod'; //identificador de la tabla
    protected $id_names = array('id_descuento_prod'); //llave primaria
    protected $field_names = array('descripcion','fecha_ini','fecha_fin','porcentaje_general','fecha_log','activo','observacion'
        ,'fecha_cierre','motivo_cierre','usuario_log'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CA_DESCUENTO_PROD'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = true; //si posee secuencia la tabla
    /*
     * campos para fecha sistema con hora
     */
    protected $campo_fecha_sistema_hora = array(
        'fecha_log'
    );
    //protected $check_exists = array('id_factura'); //para verificar que no exista la combinacion de estos campos en la tabla
    //protected $has_check_exists = true; //para acutalizar registro si valida campos en check_exists
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_descuento_prod'; //identificador unico de la tabla
// Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;
        $activo=$request['activo'];
        $id_descuento_prod =$request['id_descuento_prod'];
        $fecha_inicio=$request['fecha_ini'];
        $fecha_final=$request['fecha_fin'];
        /*
         *  Validar la operación, ya sea por SQL
         */
        //si el activo viene para actualizar a 1 validamos antes de activar
        if($activo==1){
           //Consultamos que el campo activo en realidad este cambiando a 1 
           $sql=<<<EOD
                Select activo from CA_DESCUENTO_PROD where id_descuento_prod=$id_descuento_prod
EOD;
           $records = CN_TABLE::executeSQL($sql);

           $activo_aux = $records[0]['activo'];
           //si en realidad el campo activo esta cambiando 
           if($activo!=$activo_aux){
               $sql=<<<EOD
               SELECT *
FROM ca_descuento_prod cdp
JOIN ca_descuento_prod_det cdpd
ON cdp.ID_DESCUENTO_PROD=cdpd.ID_DESCUENTO_PROD
where cdp.fecha_ini<=to_date('$fecha_final','yyyy-mm-dd') and cdp.fecha_fin>=to_date('$fecha_inicio','yyyy-mm-dd')
and cdp.activo =1 and cdpd.ID_PRODUCTO in (SELECT cdpd.id_producto
FROM ca_descuento_prod cdp
JOIN ca_descuento_prod_det cdpd
ON cdp.ID_DESCUENTO_PROD=cdpd.ID_DESCUENTO_PROD
where cdp.ID_DESCUENTO_PROD= $id_descuento_prod)
EOD;
              $records = CN_TABLE::executeSQL($sql);
              if(count($records)>0){
                  $errors['mensaje'] = "El descuento posee productos con otros descuentos activos en el rango de la fecha del descuento. Favor Verificar";
                  $errors['servicio'] = "ca_desc_prod";
              }
           }
        }
        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");
        $logger->info($request['username']);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['usuario_log']=$request['username'];
        }

        //accion update
        if ($Action == "UPDATE") {
            $request['usuario_log']=$request['username'];
            if($request['fecha_log']!=null){
                $aux=new datetime($request['fecha_log']);
                $request['fecha_log']=date_format($aux,'Y-m-d H:i:s');
            }
            
            
         }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
